<template>
  <div style="width:25%">
    <h1>{{ nonZeroConfig.length }}</h1>
    <div v-for="item in nonZeroConfig" class="mb-3">
      <component
          :is="getFacet(item.id)"
          :config="item"
          @facet-clicked="facetClicked"
      />
    </div>
  </div>
</template>

<script setup lang="ts">
  import { getFacet } from "./getFacet"
  import {FacetsConfig} from "./types";
  import {useFacets} from "./useFacets";
  import {computed, toRef} from "vue";
  import {useRoute, useRouter} from "vue-router";
  import {toggleQueryParam} from "./toggleQueryParam";

  const props = defineProps<{
    facetsConfig: FacetsConfig
    facetsIds: [String]
  }>();

  const route = useRoute();
  const router = useRouter();
  const facetsConfig = toRef(props, 'facetsConfig');
  const config = useFacets(facetsConfig, props.facetsIds, route);
  const nonZeroConfig = computed(() =>
      config.value.filter(element => element.items.length));
  const facetClicked = (facetId, item) => {
    toggleQueryParam(facetId, item.id, router, route);
  }
</script>
